
package de.ivu.elect.sitzberechnung.konflikt;

import static java.util.Collections.emptyList;
import static java.util.stream.Collectors.toList;

import java.util.Collection;
import java.util.List;

import com.google.gson.Gson;

import de.ivu.elect.sitzberechnung.Gebiet;
import de.ivu.elect.sitzberechnung.Liste;
import de.ivu.elect.sitzberechnung.SitzberechnungEntity;

public class ErgebnisKonfliktListenAuswaehlen extends AbstractErgebnisKonfliktEntitiesAuswaehlen {

  private final List<String> listeKeysAuswaehlbar;

  private final List<String> listeKeysAusgewaehlt;

  private ErgebnisKonfliktListenAuswaehlen(String wahlgebietKey, String wahlvorschlaggebietKey, Enum< ? > typ, ErgebnisKonfliktStatus ergebnisKonfliktStatus, long anzahlAuszuwaehlen,
      List<String> listeKeysAuswaehlbar, List<String> listeKeysAusgewaehlt) {
    super(wahlgebietKey, wahlvorschlaggebietKey, typ, ergebnisKonfliktStatus, anzahlAuszuwaehlen);

    this.listeKeysAuswaehlbar = listeKeysAuswaehlbar;
    this.listeKeysAusgewaehlt = listeKeysAusgewaehlt;
  }

  @Override
  public ErgebnisKonfliktArt getErgebnisKonfliktArt() {
    return ErgebnisKonfliktArt.LOSENTSCHEID_AUSWAHL_LISTEN;
  }

  public List<String> getListeKeysAuswaehlbar() {
    return listeKeysAuswaehlbar;
  }

  public List<String> getListeKeysAusgewaehlt() {
    return listeKeysAusgewaehlt;
  }

  @Override
  public boolean isFachlichGleich(ErgebnisKonflikt other) {
    return other instanceof ErgebnisKonfliktListenAuswaehlen && isFachlichGleich((ErgebnisKonfliktListenAuswaehlen) other);
  }

  protected boolean isFachlichGleich(ErgebnisKonfliktListenAuswaehlen other) {
    return super.isFachlichGleich(other) && other.getListeKeysAuswaehlbar().size() == getListeKeysAuswaehlbar().size() && other.getListeKeysAuswaehlbar().containsAll(getListeKeysAuswaehlbar());
  }

  public <E extends SitzberechnungEntity> List<E> filterListenAuswaehlbar(Collection<E> entities) {
    return filterEntitiesByEntityKeys(entities, getListeKeysAuswaehlbar());
  }

  public <E extends SitzberechnungEntity> List<E> filterListenAusgewaehlt(Collection<E> entities) {
    return filterEntitiesByEntityKeys(entities, getListeKeysAusgewaehlt());
  }

  @Override
  public String toJson() {
    return toJson(this);
  }

  public static String toJson(ErgebnisKonfliktListenAuswaehlen ergebnisKonflikt) {
    ErgebnisKonfliktEntitiesDaten daten = new ErgebnisKonfliktEntitiesDaten();
    daten.setWahlgebietKey(ergebnisKonflikt.getWahlgebietKey());
    daten.setWahlvorschlaggebietKey(ergebnisKonflikt.getWahlvorschlaggebietKey());
    daten.setLosentscheidTyp(ergebnisKonflikt.getLosentscheidTyp());
    daten.setAnzahlAuszuwaehlen(ergebnisKonflikt.getAnzahlAuszuwaehlen());
    daten.setErgebnisKonfliktStatus(ergebnisKonflikt.getErgebnisKonfliktStatus());
    daten.setListeKeysAuswaehlbar(ergebnisKonflikt.getListeKeysAuswaehlbar());
    daten.setListeKeysAusgewaehlt(ergebnisKonflikt.getListeKeysAusgewaehlt());

    return new Gson().toJson(daten);
  }

  public static ErgebnisKonfliktListenAuswaehlen fromJson(String json) {
    ErgebnisKonfliktEntitiesDaten daten = new Gson().fromJson(json, ErgebnisKonfliktEntitiesDaten.class);

    if (daten != null && !daten.isEmpty()) {
      return newInstance(daten.getWahlgebietKey(), daten.getWahlvorschlaggebietKey(), daten.getLosentscheidTyp(), daten.getErgebnisKonfliktStatus(), daten.getAnzahlAuszuwaehlen(),
          daten.getListeKeysAuswaehlbar(), daten.getListeKeysAusgewaehlt());
    }

    return null;
  }

  public static ErgebnisKonfliktListenAuswaehlen newInstance(Gebiet wahlgebiet, Gebiet wahlvorschlaggebiet, Enum< ? > typ, long anzahlAuszuwaehlen, List<Liste> auswaehlbar) {
    return newInstance(wahlgebiet == null ? "" : wahlgebiet.getKey(), wahlvorschlaggebiet == null ? "" : wahlvorschlaggebiet.getKey(), typ, ErgebnisKonfliktStatus.UNGELOEST, anzahlAuszuwaehlen,
        auswaehlbar.stream().map(SitzberechnungEntity::getKey).collect(toList()), emptyList());
  }

  public static ErgebnisKonfliktListenAuswaehlen newInstance(String wahlgebietKey, String wahlvorschlaggebietKey, Enum< ? > typ, ErgebnisKonfliktStatus ergebnisKonfliktStatus, long anzahlAuszuwaehlen,
      List<String> listeKeysAuswaehlbar, List<String> listeKeysAusgewaehlt) {
    return new ErgebnisKonfliktListenAuswaehlen(wahlgebietKey, wahlvorschlaggebietKey, typ, ergebnisKonfliktStatus, anzahlAuszuwaehlen, listeKeysAuswaehlbar, listeKeysAusgewaehlt);
  }
}
